
Base Distribution - Task # 45317

Status: Resolved Priority: Must have
Author: Sebastian Kurfuerst Category: Content Editing
Created: 2013-02-09 Assigned To: Karsten Dambekalns
Updated: 2013-05-26 Due date:
Subject: Refine / Rename node type hierarchy
Description

... as discussed with Robert on the code sprint

Naming Concept
# Node Types
old name: Content Types

## Node

## Hidable (mixin)

- defines the properties for "hidden", "hiddenBeforeDateTime", "hiddenAfterDateTime" 

## Versionable (mixin)

- adds the behavior to store multiple versions of the node

## Translatable (mixin)

- adds the behavior to translate nodes

## Folder < Node

- used for organizing nodes
- does not need an external identity, thus no URL.

## Smartfolder < Folder

- does not contain actual sub nodes
- collection is defined through a query

## Document < Node, Hidable
old name: Folder

- is "abstract", cannot be rendered as is
- sub types of Document:
    - can be addressed through a URI
    - contains one or more Section nodes which may contain content
    - can be rendered
- TODO remove title property
- TODO page tree > document tree (?)

## Page < Document

- is the default document paradigm in Neos
- introduce further properties, for example a title

## Shortcut < Document

- refers / forwards to another document

## Blog Post < Document
- introduces specific properties and sub structure

## Content < Node, Hidable
old name: ContentObject

- is not usually accessible through a URI
- can be rendered as part of a document
- may contain further content
- cannot contain documents

## Headline < Content

- introduces specific properties and template
- further content types: Text, Image, TextWithImage, Menu, Html, Plugin, Two-Columns, …

## Plugin < Content

- delegates rendering of the content to a controller

## ContentCollection < Content
old name: Section

- contains content nodes

see attached images.

Related issues:
related to Base Distribution - Task # 52020: clean up Node Structure between ... Accepted 2013-09-16
related to Base Distribution - Work Package # 44971: TYPO3 Neos API Definition Accepted 2013-06-30

Associated revisions
Revision a68e2b5a - 2013-05-23 22:13 - Karsten Dambekalns

[TASK] Avoid migration to be applied (dummy commit)

This is an empty commit to avoid the migration in the footer from being
applied.

Change-Id: I7e94cc3b2bf6fcbbe86f3aece3ee29fdd2d22933
Related: #45317
Migration: TYPO3.Neos.NodeTypes-130516220640

Revision 6e133436 - 2013-05-23 22:27 - Karsten Dambekalns

[TASK] Adjust to renamed node types

Change-Id: Iec6daabaeb6740b3cad5fbfff94509c0d872aabe
Related: #45317
Migration: TYPO3.Neos.NodeTypes-130516220640

Revision 0ede2b8e - 2013-05-23 22:38 - Karsten Dambekalns

[!!!][TASK] Remove TYPO3.TYPO3CR:Folder node type

Change-Id: Ia1e0efbe4ac1818a6143b2ab27cb9626e3115805
Related: #45317

Revision a6431b64 - 2013-05-23 22:38 - Karsten Dambekalns

[TASK] Adjust to renamed node types

Change-Id: I06eee6d1e4bcff702b67c28dc35d3314d6e4fa44
Related: #45317
Migration: TYPO3.Neos.NodeTypes-130516220640

Revision 052de026 - 2013-05-24 15:12 - Karsten Dambekalns

[TASK] Adjust to TYPO3.TYPO3CR:Folder removal

Change-Id: Iad5ed08448f6ef5285e3fcfae8f00a94186ac28b
Related: #45317
Migration: TYPO3.TYPO3CR-130523180140

Revision 9cd27b77 - 2013-05-24 15:12 - Karsten Dambekalns

[!!!][TASK] Make node types and TypoScript more consistent

This change moves some of the existing node types from the package
TYPO3.Neos.NodeTypes here:

    -  TYPO3.Neos.NodyTypes:AbstractNode -> TYPO3.Neos:Node
    -  TYPO3.Neos.NodyTypes:Page -> TYPO3.Neos:Page
    -  TYPO3.Neos.NodyTypes:Shortcut -> TYPO3.Neos:Shortcut
    -  TYPO3.Neos.NodyTypes:Folder -> TYPO3.Neos:Document
    -  TYPO3.Neos.NodyTypes:ContentObject -> TYPO3.Neos:Content
    -  TYPO3.Neos.NodyTypes:Section -> TYPO3.Neos:ContentCollection
    -  TYPO3.Neos.NodyTypes:Plugin -> TYPO3.Neos:Plugin

It adds these new ones, being mixins:

    -  TYPO3.Neos:Hidable
    -  TYPO3.Neos:Timable

The TypoScript is cleaned up to follow the renamed node types and for
more overall consistency.

Two new migrations (one for code and one for TYPO3CR) help with the
adjustments needed to userland code. See the corresponding commit
in TYPO3.Neos.NodeTypes for instructions.

Change-Id: Ic23ef07664972d7beddf4c3e05affc9d25faf102
Resolves: #45317
Migration: TYPO3.Neos.NodeTypes-130516220640
Migration: TYPO3.TYPO3CR-130523180140
Revision 50e7ee93 - 2013-05-24 15:15 - Karsten Dambekalns

[!!!][TASK] Make node types and TypoScript more consistent

This change renames and moves some of the existing node types in
TYPO3.Neos.NodeTypes to TYPO3.Neos:

    -  TYPO3.Neos.NodyTypes:AbstractNode -> TYPO3.Neos:Node
    -  TYPO3.Neos.NodyTypes:Page -> TYPO3.Neos:Page
    -  TYPO3.Neos.NodyTypes:Shortcut -> TYPO3.Neos:Shortcut
    -  TYPO3.Neos.NodyTypes:Folder -> TYPO3.Neos:Document
    -  TYPO3.Neos.NodyTypes:ContentObject -> TYPO3.Neos:Content
    -  TYPO3.Neos.NodyTypes:Section -> TYPO3.Neos:ContentCollection
    -  TYPO3.Neos.NodyTypes:Plugin -> TYPO3.Neos:Plugin

The TYPO3.Neos.NodeTypes:Folder type is removed and can be replaced by
TYPO3.Neos:Document if needed.

The TypoScript is cleaned up to follow the renamed node types and for
more overall consistency.

Two new migrations (one for code and one for TYPO3CR) help with the
adjustments needed to userland code.

To adjust the code use this, it should be enough to run this on your
site package(s) and plugins, if any::

./flow flow:core:migrate --package-key &lt;sitepackagekey&gt;

To adjust the content stored in TYPO3CR use this (if you have no
unpublished changes "live" should be the only workspace in need of
migration)::

./flow node:migrate &lt;workspace&gt; 20130516212400

Change-Id: I17a7793c5139a0d3eb63fcacfe9db52db5b0ec35
Resolves: #45317
Migration: TYPO3.Neos.NodeTypes-130516220640
Migration: TYPO3.TYPO3CR-130523180140

Revision 81b77c88 - 2013-05-24 15:46 - Sebastian Kurfuerst

[BUGFIX] update node migration to include shortcuts

Related: #45317
Change-Id: Ieeeeff66906955d744fc1fc17d1f68168159c186

Revision 0c776aff - 2013-05-24 15:59 - Sebastian Kurfuerst

[TASK] add "down"-migration for Shortcut

I accidentally merged Ieeeeff66906955d744fc1fc17d1f68168159c186
while reviewing it.
Related: #45317
Change-Id: Ib7f507a2b9fc85694528ccea94e17c093cfc0d75

Revision 085e58db - 2013-05-25 17:07 - Aske Ertmann

[TASK] Tiny cleanup in node types configuration

Change-Id: If94c6a5a753be51fe854400a5e12fc3bdc5ecdb8
Related: #45317

Revision 3231f861 - 2013-05-26 10:25 - Aske Ertmann

[BUGFIX] Replace remaining t3- usages after node types restructuring

Also renames section to content in accordance to the new
naming in TypoScript.

Change-Id: Ib860f4ecc84f8fbe2d201b712331723e9a04ebbc
Related: #48348
Related: #45317

Revision a7f8c5c3 - 2013-05-26 10:42 - Aske Ertmann

[TASK] Cleanup neos view helper namespaces

    -  Consistently <neos:*… /> now

Change-Id: I3579ed9d9994e16036df1730e4b8aa2c5e02dda5
Related: #45317

Revision 54030b26 - 2013-05-26 11:03 - Aske Ertmann

[BUGFIX] Make menu TS object prototype template TS object

Since the menu doesn't prototype the template TypoScript object,
the node is never assigned to the view which is needed in the template.

Change-Id: I1136531d2a3f4079c4c8b8a66111109a76e976b0
Related: #45317

Revision 67d823ac - 2013-05-26 11:50 - Aske Ertmann

[TASK] Cleanup neos view helper namespaces

    -  Consistently <neos:*… /> now

Change-Id: I700daa771ec207883f41a274814d150a828805e1
Related: #45317
Revision 53a611f8 - 2013-05-26 11:51 - Aske Ertmann

[TASK] Replace usages of folder with document

Change-Id: I3364be4b784786d757e52473827316fd851f775e
Related: #45317

Revision a9e65330 - 2013-05-26 16:56 - Aske Ertmann

[BUGFIX] Assign page node properties to correct inspector group

Change-Id: I99017968e009ed760cf78d47db3d42b2c2db10f4
Related: #45317

Revision 9824eb1f - 2013-05-26 18:27 - Aske Ertmann

[TASK] Add default label for column node type

Change-Id: Ic384f6ee6e41b50966ac1699836f38755149ee32
Related: #45317

Revision 8195d0fc - 2013-05-26 21:46 - Aske Ertmann

[BUGFIX] Adjust workspaces module to node type restructuring

Change-Id: Idc93553864c374950d1bf5ab57f4415f4ac94fa1
Related: #45317

Revision 1d9264c7 - 2013-06-20 14:01 - Aske Ertmann

[TASK] Adjust documentation to node types/TypoScript restructuring

    -  Replace usages of n: with neos:
    -  Replace ts:renderTypoScript with ts:render
    -  Replace slashes with dots in ts:render ViewHelper
    -  Replace "section" mentions with content collection or content

Change-Id: I1d87bcaf6bea31a86b33a484c586d01a7978a7c9
Related: #45317

Revision a05c20a0 - 2013-07-06 22:52 - Aske Ertmann

[TASK] Add support for abstract node types

Change-Id: I04c8688bb0b2307a7a531720981f7bdb013b6ae8
Related: #45317
Reviewed-on: https://review.typo3.org/21076
Reviewed-by: Tim Kandel
Tested-by: Tim Kandel
Reviewed-by: Sebastian Kurfuerst
Tested-by: Sebastian Kurfuerst

Revision 3c0656b4 - 2013-09-16 12:37 - Aske Ertmann

[TASK] Mark document node type abstract

Change-Id: I5d131c26ca896999880efb173f695cae2537d69a
Related: #45317
Reviewed-on: https://review.typo3.org/22862
Reviewed-by: Aske Ertmann
Tested-by: Aske Ertmann
Tested-by: Mr. Hudson
Reviewed-by: Sebastian Kurfuerst
Tested-by: Sebastian Kurfuerst

History
#1 - 2013-05-16 09:43 - Sebastian Kurfuerst

see http://forge.typo3.org/issues/44928

#2 - 2013-05-16 14:56 - Sebastian Kurfuerst
- File naming-hierarchy.graffle added
- File naming-hierarchy.png added
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns

#3 - 2013-05-20 17:25 - Karsten Dambekalns
- % Done changed from 0 to 40

Worked on this after the Karlsruhe sprint, need to clean up and push for review. For sure we need to discuss some more details :)

#4 - 2013-05-21 19:17 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20960

#5 - 2013-05-21 19:28 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#6 - 2013-05-21 19:29 - Karsten Dambekalns
- % Done changed from 40 to 80

The last 20%, you know ;)

2015-08-04 7/9

https://review.typo3.org/22862
http://forge.typo3.org/issues/44928
https://review.typo3.org/20960


#7 - 2013-05-21 19:54 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20960

#8 - 2013-05-23 23:25 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#9 - 2013-05-23 23:26 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20960

#10 - 2013-05-23 23:28 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#11 - 2013-05-24 12:35 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#12 - 2013-05-24 13:30 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#13 - 2013-05-24 13:40 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#14 - 2013-05-24 15:12 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20963

#15 - 2013-05-24 15:13 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20960
#16 - 2013-05-24 15:15 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20960

#17 - 2013-05-24 15:36 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 80 to 100

Applied in changeset commit:9cd27b77cb9f1243453986603f50168f9a86b1b0.

#18 - 2013-05-25 17:02 - Aske Ertmann

Page options are broken

#19 - 2013-05-26 18:14 - Aske Ertmann

Aske Ertmann wrote:

Page options are broken

Fixed with https://review.typo3.org/#/c/21066/

Files
naming-hierarchy.graffle 21.8 kB 2013-05-16 Sebastian Kurfuerst
naming-hierarchy.png 64.4 kB 2013-05-16 Sebastian Kurfuerst
